SystemOrganization addCategory: #ConfigurationOfKozen!

Object subclass: #ConfigurationOfKozen
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfKozen'!

!ConfigurationOfKozen commentStamp: 'StephaneDucasse 1/23/2012 21:34' prior: 0!
(ConfigurationOfKozen project version: '0.9') load: 'full'

(ConfigurationOfKozen project version: '0.9') record: 'full'
		
	!

!ConfigurationOfKozen class methodsFor: 'as yet unclassified' stamp: 'sd 1/7/2012 12:24'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfKozen class methodsFor: 'as yet unclassified' stamp: 'sd 1/7/2012 12:23'!
compareVersions
	"Compare previous version to development version"

	"self compareVersions"

	"Note: you need 1.0-beta.28 or later for the class MetacelloToolBox"

	self ensureMetacello.
	((Smalltalk at: #MetacelloToolBox) compareVersionsIn: self) inspect
! !

!ConfigurationOfKozen class methodsFor: 'as yet unclassified' stamp: 'sd 1/7/2012 12:23'!
createNewDevelopmentVersion
	"Create a new development version using the #stable version as model."

	"self createNewDevelopmentVersion"
	
	"Note: you need 1.0-beta.28 or later for the class MetacelloToolBox"

	self ensureMetacello.
	(Smalltalk at: #MetacelloToolBox) createNewDevelopmentVersionIn: self description: ''! !

!ConfigurationOfKozen class methodsFor: 'as yet unclassified' stamp: 'sd 1/7/2012 12:24'!
ensureMetacello
	"Bootstrap Gofer (if necessary), bootstrap ConfigurationOfMetacello (using old Gofer API), then load the latest 
	version of Metacello itself."

	Smalltalk at: #MetacelloProject ifAbsent: [
		Smalltalk at: #Gofer ifAbsent: [
			"Current version of Gofer from which to bootstrap - as of 1.0-beta.21"
			self bootstrapPackage: 'Gofer-Core-lr.115' from: 'http://seaside.gemstone.com/ss/metacello' ].
		Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
			gofer := goferClass new
				url: 'http://seaside.gemstone.com/ss/metacello';
				yourself.
			[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
			gofer load ].
		"load 'default' group of Metacello"
		(Smalltalk at: #ConfigurationOfMetacello) perform: #load ]! !

!ConfigurationOfKozen class methodsFor: 'as yet unclassified' stamp: 'sd 1/7/2012 12:23'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfKozen class methodsFor: 'as yet unclassified' stamp: 'sd 1/7/2012 12:23'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfKozen class methodsFor: 'as yet unclassified' stamp: 'sd 1/7/2012 12:23'!
load
	"self load"

	^self project latestVersion load! !

!ConfigurationOfKozen class methodsFor: 'as yet unclassified' stamp: 'sd 1/7/2012 12:24'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfKozen class methodsFor: 'as yet unclassified' stamp: 'sd 1/7/2012 12:23'!
project

	^self new project! !

!ConfigurationOfKozen class methodsFor: 'as yet unclassified' stamp: 'sd 1/7/2012 12:23'!
updateToLatestPackageVersions: descriptionString
	"Updates mcz file versions in current version"

	"self updateToLatestPackageVersions: '- fixed a bug'"

	"Note: you need 1.0-beta.28 or later for the class MetacelloToolBox"

	self ensureMetacello.
	((Smalltalk at: #MetacelloToolBox) updateToLatestPackageVersionsIn: self description: descriptionString) isEmpty
		ifTrue: [ self inform: 'All specs up to date' ]! !

!ConfigurationOfKozen methodsFor: 'baseline' stamp: 'sd 1/9/2012 17:38'!
baseline100: spec 
	<version: '1.0-baseline'>
	
	spec for: #pharo do: [
		spec blessing: #baseline.
		spec repository: 'http://www.squeaksource.com/Kozen'.
		spec package: 'Kozen'.
		spec package: 'KoCizen' with: [spec requires: 'Citezen'].
		
		spec group: 'default' with: #('Kozen'). 
		spec group: 'full' with: #('Kozen' 'KoCizen'). 
		
	spec project: 'Citezen' with: [
			spec className: 'ConfigurationOfCitezen';
			versionString: #stable;
			loads: #('NoWeb' );
			repository: 'http://www.squeaksource.com/Citezen'.
			]
		].
	! !

!ConfigurationOfKozen methodsFor: 'baseline' stamp: 'StephaneDucasse 1/23/2012 21:30'!
baseline101: spec 
	<version: '1.1-baseline'>
	
	spec for: #pharo do: [
		spec blessing: #baseline.
		spec repository: 'http://www.squeaksource.com/Kozen'.
		spec package: 'Kozen'.
		spec package: 'KoCizen' with: [spec requires: 'Citezen'].
		spec package: 'KozStef' with: [spec requires: 'KoCizen'].
		
		spec group: 'default' with: #('Kozen'). 
		spec group: 'full' with: #('Kozen' 'KoCizen' 'KozStef'). 
		
	spec project: 'Citezen' with: [
			spec className: 'ConfigurationOfCitezen';
			versionString: #stable;
			loads: #('NoWeb' );
			repository: 'http://www.squeaksource.com/Citezen'.
			]
		].
	! !

!ConfigurationOfKozen methodsFor: 'utils' stamp: 'sd 1/7/2012 12:14'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear.
		"use atomic load on GemStone to resolve some loading issues"
		Smalltalk at: #SystemVersion ifAbsent: [ project loadType: #atomic ]. 
		project ]! !

!ConfigurationOfKozen methodsFor: 'symbolic versions' stamp: 'StephaneDucasse 1/18/2012 17:47'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'pharo1.3.x' version: '0.8'.
! !

!ConfigurationOfKozen methodsFor: 'versions' stamp: 'StephaneDucasse 1/18/2012 17:47'!
version08: spec
	<version: '0.8' imports: #('1.0-baseline')>
	
	spec for: #'pharo' do: [
		spec description: 'Before Stef site refactorings'.
		spec author: 'StephaneDucasse'.
		spec timestamp: '18/01/2012 17:45'.
		spec 
			package: 'Kozen' with: 'Kozen-sd.21';
			package: 'KoCizen' with: 'KoCizen-sd.4'.].
! !

!ConfigurationOfKozen methodsFor: 'versions' stamp: 'StephaneDucasse 2/5/2012 15:25'!
version09: spec
	<version: '0.9' imports: #('1.1-baseline')>
	
	spec for: #'pharo' do: [
		spec description: 'Editorial page'.
		spec author: 'StephaneDucasse'.
		spec timestamp: '18/01/2012 17:45'.
		spec 
			package: 'Kozen' with: 'Kozen-StephaneDucasse.26';
			package: 'KoCizen' with: 'KoCizen-StephaneDucasse.5';
			package: 'KozStef' with: 'KozStef-StephaneDucasse.5' .].
! !
